#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
template <class T> using indexed_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
#define pb push_back
template<class T> using pqg = priority_queue<T,vector<T>,greater<T>>;
const char nl = '\n';
const long long int ll_MAX=9223372036854775807;


int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);





     int tp;
    cin>>tp;
    int n,k;
    cin>>n>>k;
    vector<int> a(n);
    for(int i =0;i<n;i++){
        cin>>a[i];
    }
    vector<int> ans;
    bool globaltc=false;
    //tc1
    bool tc1=true;
    int sumatc1 = 0;
    for(int i =0;i<n;i++){

        if(a[i]!=a[0])tc1=false;
        if(sumatc1<=a[i])sumatc1+=1;
    else sumatc1-=1;
    }

    bool tc2 = true;
    int cntmns1=0;
    int cnt1=0;
    for(int i =0;i<n;i++){
        if(a[i]!=1 && a[i]!=-1)tc2=false;
        if(a[i]==1)cnt1+=1;
        if(a[i]==-1)cntmns1-=1;

    }
    bool tc3 = true;
    for(int i =0;i<n;i++){
        if(a[i]!=i+1)tc3=false;

    }

    if(tc1){
        if(sumatc1!=k)cout<<"NE";
        else{
            cout<<"DA"<<nl;
            if(tp==1)for(int i =0;i<n;i++)cout<<a[i]<<" ";
        }
    }
    else if(tc2){
        if(cnt1+cntmns1!=k || cnt1+cntmns1<-1 || cnt1+cntmns1>2)cout<<"NE";
        else{
            cout<<"DA"<<nl;
            if(tp==1){
                for(int i =0;i<min(cnt1,abs(cntmns1));i++){
                    cout<<1<<" "<<-1<<" ";
                    cnt1--;
                    cntmns1++;
                }
                if(cnt1!=0)for(int i =0;i<cnt1;i++)cout<<1<<" ";
                else for(int i =0;i<abs(cntmns1);i++)cout<<-1<<" ";
            }
        }
    }
    else if(tc3){
        if(k<=0 || abs(n-k)%2==1)cout<<"NE";
        else{
            cout<<"DA"<<nl;
            if(tp){
                for(int i =0;i<(n+k)/2;i++){
                    cout<<n-i<<" ";
                }
                for(int i =0;i<(n-((n+k)/2));i++){
                    cout<<i+1<<" ";
                }

                            }
        }


    }


}